﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PeriodicTableMaker
{
    public partial class Form1 : Form
    {
        String[,] fileList = new String[18, 9];
        String[] lines;

        Font mainFont = new Font("メイリオ", 13);
        Color mainColor = Color.White;

        public Form1()
        {
            InitializeComponent();
        }

        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            Point p = pictureBox1.PointToClient(System.Windows.Forms.Cursor.Position);
            p.X -= 24;
            p.Y -= 30;
            p.X /= 64;
            p.Y /= 64;
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                fileList[p.X, p.Y] = openFileDialog1.FileName;
                openFileDialog1.FileName = "";
                redrawImage();
            }
        }

        private void redrawImage()
        {
            Image img = Image.FromFile("table.png");
            Graphics g = Graphics.FromImage(img);
            for (int x = 0; x < 18; x++)
            {
                for (int y = 0; y < 9; y++)
                {
                    int index = (y * 18 + x);
                    if (fileList[x, y] != null && File.Exists(fileList[x, y]))
                    {
                        g.DrawImage(Image.FromFile(fileList[x, y]), new Rectangle(new Point(x * 64 + 24, y * 64 + 30), new Size(64, 64)));
                    }
                    g.DrawString(lines[index], mainFont, new SolidBrush(mainColor), new Point(x * 64 + 25, y * 64 + 72));
                }
            }
            g.Dispose();
            pictureBox1.Image = img;
        }

        private Color getPointColor()
        {
            Point p = pictureBox1.PointToClient(System.Windows.Forms.Cursor.Position);
            Color c = ((Bitmap)pictureBox1.Image).GetPixel(p.X, p.Y);
            return c;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            StreamReader sr = new StreamReader("Data.txt");
            lines = sr.ReadToEnd().Replace("\r\n", "\n").Split('\n');
            sr.Close();
            redrawImage();
        }

        private void フォントFToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (fontDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                mainFont = fontDialog1.Font;
                redrawImage();
            }
        }

        private void 文字色ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                mainColor = colorDialog1.Color;
                redrawImage();
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            if ((e.Button & System.Windows.Forms.MouseButtons.Right) == System.Windows.Forms.MouseButtons.Right)
            {
                Point p = pictureBox1.PointToClient(System.Windows.Forms.Cursor.Position);
                p.X -= 24;
                p.Y -= 30;
                p.X /= 64;
                p.Y /= 64;
                fileList[p.X, p.Y] = "";
                redrawImage();
            }
        }

        private void 新規作成NToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error );
        }

        private void 開くOToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void 上書き保存SToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void 印刷PToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void 印刷プレビューVToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void 終了XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("体験版では使用できません", "冗談", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void 名前を付けて保存AToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                pictureBox1.Image.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Png);
                saveFileDialog1.FileName = "*.png";

            }
        }
    }
}
